@echo off

setlocal  ENABLEDELAYEDEXPANSION
set /A flag=100

set section=
set errorMessage=
set /A errorFlag=0

set InstAgent=0
set InstAgentLI=0
set InstManager=0
set InstManagerLI=0

set stoppedService=

set workDir=%~dp0

rem Check the os if is 32 bit---------- 
set 32Flag=0
if /i "%PROCESSOR_IDENTIFIER:~0,3%"=="X86" (
    set 32Flag=1
)

set regSoftWare=HKLM\Software
set regAlertMan=HKLM\Software\NEC\ESMAlertMan
if !32Flag!==0 (
    set regSoftWare=HKLM\Software\Wow6432Node
    set regAlertMan=HKLM\Software\Wow6432Node\NEC\ESMAlertMan
)

rem get AM work directory path
REG QUERY "!regAlertMan!" /v TempDir 1>nul 2>nul
if NOT !ERRORLEVEL!==0 (
    echo Get work directory failed. Update stopped.
    goto Terminate
)
for /F "tokens=2*" %%i in ('REG QUERY "!regAlertMan!" /v TempDir') do (
    set logFile="%%jAMUpdate.log"
)

echo ============================================================ >>!logFile!
echo ============================================================ >>!logFile!
echo ================ !time! Start AMUpdate ================ >>!logFile!
echo workDir=!workDir! >>!logFile!
echo logFile=!logFile! >>!logFile!
echo PROCESSOR_IDENTIFIER=%PROCESSOR_IDENTIFIER% >>!logFile!
echo 32Flag=!32Flag! >>!logFile!
echo regAlertMan=!regAlertMan! >>!logFile!

rem read AMUpdate.inf
echo ----------Read AMUpdate.inf---------- >>!logFile!
for /F "usebackq tokens=1* delims==" %%i in ("!workDir!AMUpdate.inf") do (
    set deleteSpaceString=%%i
    call:DeleteSpace
    set line=!deleteSpaceString!

    set fistCharacter=!line:~0,1!
    if "!fistCharacter!"=="-" (
        set /A flag=100
    ) else (
        if "!fistCharacter!"=="[" (
            call:Dispatch
            if NOT !errorFlag!==0 (
                call:RestartService
                set errorMessage=!errorMessage! Update Stopped.
                goto EndPrint
            )
            call:Reset

            set section=!line:~1,-1!
            rem echo section=!section! >>!logFile!
        ) else (
            set keyName!flag!=!deleteSpaceString!
            rem echo keyName!flag!=!deleteSpaceString! >>!logFile!

            set deleteSpaceString=%%j
            call:DeleteSpace
            set keyValue!flag!=!deleteSpaceString!
            rem echo keyValue!flag!=!deleteSpaceString! >>!logFile!

	    set /A flag=!flag!+1
        )
    )
)

call:Dispatch
if !errorFlag!==0 (
    set errorMessage=AMUpdate complete successfully.    
) else (
    set errorMessage=!errorMessage!. Update Stopped.
)

call:RestartService
goto EndPrint

:DeleteSpace (
    :lineStart(
        set fistCharacter=!deleteSpaceString:~0,1!
        if "!fistCharacter!"==" " (
            set tempString=!deleteSpaceString:~1!
            set deleteSpaceString=!tempString!
            goto lineStart
        )
    )

    :lineEnd (
        set endCharacter=!deleteSpaceString:~-1!
        if "!endCharacter!"==" " (  
            set tempString=!deleteSpaceString:~0, -1!
	    set deleteSpaceString=!tempString!
            goto lineEnd
        )
    )
    goto END
)

:Reset (
    set /A flag=0

    set section=
    for /L %%i in (0, 1, 10) do (
        set KeyName%%i=
        set KeyValue%%i=
    )

    goto END
)

:Dispatch (    
    echo ----------Start Dispatch---------- >>!logFile!

    echo section=!section!>>!logFile!
    if "!section!"=="" (
        goto END
    )
    
    if /i "!section!"=="Title" (
        goto Title
    )
    
    if /i "!section!"=="Administrator" (
        goto Administrator
    )

    if /i "!section!"=="AMVersion" (
        goto AMVersion
    ) 
    
    if /i "!section!"=="AMEXTVersion" (
        goto AMEXTVersion
    ) 
    
  
    if /i "!section!"=="Language" (
        goto Language
    )

    if /i "!section!"=="AMSADM" (
        goto AMSADM
    )

    if /i "!section!"=="Product" (
        goto Product
    )

    if /i "!section!"=="Excute" (
        goto Excute
    )

    if /i "!section!"=="Service" (
        goto Service
    )

    if /i "!section!"=="File" (
        goto File
    )

    if /i "!section!"=="Registry" (
        goto Registry
    )

    if /i "!section!"=="StopService" (
        goto StopService
    )

    if /i "!section!"=="CopyFile" (
        goto CopyFile
    )

    if /i "!section!"=="ImportRegistry" (
        goto ImportRegistry
    )

    if /i "!section!"=="AddRegistry" (
        goto AddRegistry
    )

    if /i "!section!"=="DelRegistry" (
        goto DelRegistry
    )

    goto END
)

:Title (
    echo This update is !KeyValue0! >>!logFile!
    echo !KeyValue0!
    goto END
)

rem check if the current user is administrators
:Administrator (
    echo ----------Start check if the current user is administrators---------- >>!logFile!
    set check=!keyValue0!
    echo check=!check! >>!logFile!
    if /i NOT "!check!"=="TRUE" (
        goto END
    )
    echo Check if the current user is Administrator
    CheckAdmin.exe 
    echo ----------checkAdmin.exe result is %ERRORLEVEL%---------- >>!logFile!
    if NOT !ERRORLEVEL!==0 (
        set /A errorFlag=1
        if !ERRORLEVEL!==1 (
        set errorMessage=The current user is not administrator, ^
please login using account with administrator privilege.
        goto END
        ) else (
        set errorMessage=Error occured when check if the current user is administrator.
         )
     )
    echo ----------END check if the current user is administrators---------- >>!logFile!
    goto END
)

:AMVersion (
    echo ----------Start check version of Alert Manager---------->>!logFile!

    set check=!keyValue0!
    echo check=!check! >>!logFile!
    if /i NOT "!check!"=="TRUE" (
        goto END
    )

    echo Check version of Alert Manager 
    
    set minVersion=!keyValue1!
    echo minVersion=!minVersion! >>!logFile!
    if "!minVersion!"=="" (
        set /A errorFlag=1
        set errorMessage=Failed to get AMCore minVersion from AMUpdate.inf.
        goto END
    )
    
    set maxVersion=!keyValue2!
    echo maxVersion=!maxVersion! >>!logFile!
    if "!maxVersion!"=="" (
        set /A errorFlag=1
        set errorMessage=Failed to get AMCore maxVersion from AMUpdate.inf.
        goto END
    )

    call:GetInstAMVer
    echo instVersion=!instVersion! >>!logFile!
    if "!instVersion!"=="" (
        set /A errorFlag=1
        set errorMessage=AMCore is not installed.
        goto END
    ) 

    set number1=!instVersion!
    set number2=!minVersion!
    call:CompareNumber
    if !compare!==-1 (
        echo inst version less than minversion >>!logFile!
        set /A errorFlag=1
        set errorMessage=The update is not suitable for AMCore version !instVersion!.
        goto END
    ) 
    
    set number2=!maxVersion!
    call:CompareNumber
    if !compare!==1 (
        echo inst version great than max version >>!logFile!
        set /A errorFlag=1
        set errorMessage=The update is not suitable for AMCore version !instVersion!.
        goto END
    )
    
    echo ----------End check version of Alert Manager---------- >>!logFile!
    goto END
)

:GetInstAMVer (
    echo ----------Start get AMCore version from registry---------- >>!logFile!
    set instVersion=

    REG QUERY "!regAlertMan!" /v AMVer >>!logFile! 2>nul
    if NOT !ERRORLEVEL!==0 (
        echo !regAlertMan! /v AMVer not exist >>!logFile!
    ) else (
        echo !regAlertMan! /v AMVer exist >>!logFile!
        for /F "tokens=2*" %%j in ('REG QUERY "!regAlertMan!" /v AMVer') do (
            set instVersion=%%k
        )
    )

    if "!instVersion!"=="" (
        REG QUERY "!regAlertMan!" /v CurrentVersion >>!logFile! 2>nul
        if NOT !ERRORLEVEL!==0 (
            echo !regAlertMan! /v CurrentVersion not exist >>!logFile!
        ) else (
            echo !regAlertMan! /v CurrentVersion exist >>!logFile!
            for /F "tokens=2*" %%j in ('REG QUERY "!regAlertMan!" /v CurrentVersion')do (
                set instVersion=%%k
            )
        )
    )

    echo ----------End get AMCore version from registry---------- >>!logFile!
    goto END
)

:AMEXTVersion (
    echo ----------Start check version of WebSAM AlertManager---------->>!logFile!

    set check=!keyValue0!
    echo check=!check! >>!logFile!
    if /i NOT "!check!"=="TRUE" (
        goto END
    )

    echo Check version of WebSAM AlertManager
    
    set minVersion=!keyValue1!
    echo minVersion=!minVersion! >>!logFile!
    if "!minVersion!"=="" (
        set /A errorFlag=1
        set errorMessage=Failed to get WebSAM AlertManager minVersion from AMUpdate.inf.
        goto END
    )
    
    set maxVersion=!keyValue2!
    echo maxVersion=!maxVersion! >>!logFile!
    if "!maxVersion!"=="" (
        set /A errorFlag=1
        set errorMessage=Failed to get WebSAM AlertManager maxVersion from AMUpdate.inf.
        goto END
    )

    call:GetInstAMExtVer
    echo instVersion=!instVersion! >>!logFile!
    if "!instExtVersion!"=="" (
        set /A errorFlag=1
        set errorMessage=WebSAM AlertManager is not installed.
        goto END
    ) 

    set number1=!instExtVersion!
    set number2=!minVersion!
    call:CompareNumber
    if !compare!==-1 (
        echo inst version less than minversion >>!logFile!
        set /A errorFlag=1
        set errorMessage=The update is not suitable for WebSAM AlertManager version !instExtVersion!.
        goto END
    ) 
    
    set number2=!maxVersion!
    call:CompareNumber
    if !compare!==1 (
        echo inst version great than max version >>!logFile!
        set /A errorFlag=1
        set errorMessage=The update is not suitable for WebSAM AlertManager version !instExtVersion!.
        goto END
    )
    
    echo ----------End check version of WebSAM AlertManager---------- >>!logFile!
    goto END
)

:GetInstAMExtVer (
    echo ----------Start get WebSAM AlertManager version from registry---------- >>!logFile!
    set instVersion=

    REG QUERY "!regAlertMan!" /v AMExtVer >>!logFile! 2>nul
    if NOT !ERRORLEVEL!==0 (
        echo !regAlertMan! /v AMExtVer not exist >>!logFile!
    ) else (
        echo !regAlertMan! /v AMExtVer exist >>!logFile!
        for /F "tokens=2*" %%j in ('REG QUERY "!regAlertMan!" /v AMExtVer') do (
            set instExtVersion=%%k
        )
    )

    echo ----------End get WebSAM AlertManager version from registry---------- >>!logFile!
    goto END
)

:CompareNumber (
    echo ----------Start compare number---------- >>!logFile!

    echo number1=!number1! >>!logFile!
    echo number2=!number2! >>!logFile!

    set /A compare=0

    set number=!number1!
    call:DisplitNumber
    set /A major1=!major!
    set minor1=!minor!

    set number=!number2!
    call:DisplitNumber
    set /A major2=!major! 
    set minor2=!minor!
    
    if /i !major1! LSS !major2! (
        set /A compare=-1
    ) else if /i !major1! GTR !major2! (
        set /A compare=1
    ) else (
        if /i "!minor1!" LSS "!minor2!" (
            set /A compare=-1
        ) else if /i "!minor1!" GTR "!minor2!" (
            set /A compare=1
        ) else (
            set /A compare=0
        ) 
    )
    echo compare=!compare! >>!logFile!
    echo ----------END compare version---------- >>!logFile!
    goto END
)

:DisplitNumber (    
    echo ----------Start displit number---------- >>!logFile!
    echo number=!number! >>!logFile!
    set major=000
    set minor=000
    for /F "tokens=1,2 delims=." %%j in ("!number!") do (
        set /A major=%%j
        set minor=%%k
    )
    
    echo major=!major! >>!logFile!
    echo minor=!minor! >>!logFile!
    
    echo ----------END displit number---------- >>!logFile!
    goto END
)

:StringLength (
    echo string=!string! >>!logFile!
    set /A length=0
    
    
    :count
    if "!string!"=="" (
        goto END
    )
    set char=!string:~0,1!
    if NOT "!char!"=="" (
        set /A length=!length!+1
        set string=!string:~1!
        goto count
    )    
    
    goto END
)

:Language (
    echo ----------Start language of Alert Manager---------- >>!logFile!

    set check=!keyValue0!
    echo check=!check! >>!logFile!
    if /i NOT "!check!"=="TRUE" (
        goto END
    )

    echo Check language of Alert Manager 

    set reqLang=!keyValue1!
    echo reqLang=!reqLang! >>!logFile!
    set instLang=   
    REG QUERY "!regAlertMan!" /v InstallType >>!logFile! 2>nul
    if NOT !ERRORLEVEL!==0 (
        echo !regAlertMan! /v InstallType not exist >>!logFile!
    ) else (
        echo !regAlertMan! /v InstallType exist >>!logFile!
        for /F "tokens=2*" %%j in ('REG QUERY "!regAlertMan!" /v InstallType') do (
            set instLang=%%k
        )  
    )
    echo instLang=!instLang! >>!logFile!  
    
    if /i NOT "!reqLang!"=="!instLang!" (
        set /A errorFlag=1
        set errorMessage=The language is different from which has installed.
    )

    echo ----------End check language---------- >>!logFile! 
    goto END
)

:AMSADM (
    echo ----------Start Check if amsadm is opened---------- >>!logFile!

    set check=!keyValue0!
    echo check=!check! >>!logFile!
    if /i NOT "!check!"=="TRUE" (
        goto END
    )

    echo Check AMSADM

    :retry
    set /A open=1
    tasklist|find /i "AMSADM.exe" >>!logFile! ||set /A open=0
    echo open=!open! >>!logFile!
    if !open!==0 (
        goto END
    )
    
    set select=
    set /P select="AMSADM.exe is opened, please close it first.R(Retry), other key to exit."
    echo select=!select! >>!logFile!
    if /i NOT "!select!"=="R" (
        set /A errorFlag=1
        set errorMessage=AMSADM.exe is opened.
        goto END
    ) else (
        goto retry
    )
    echo ----------End check AMSADM---------- >>!LogFile!
    goto END
)

:Product (
    echo ----------Start check if product(s) is installed---------- >>!logFile!

    set check=!keyValue0!
    echo check=!check! >>!logFile!
    if /i NOT "!check!"=="TRUE" (
        goto END
    )

    echo Check if product(s) is installed

    set relation=!keyValue1!
    echo relation=!relation! >>!logFile!

    set /A exists=1
    set allProduct=
    set keyValue11=
    for /L %%i in (2, 1, 11) do (
        set productInst=!keyValue%%i!
        echo productInst=!productInst! >>!logFile!
        if "!productInst!"=="" (
            if !exists!==0 (
                set /A errorFlag=1
                set allProduct=!allProduct:~1!
                set errorMessage=You must install one of those poduct(s^) as following:!allProduct!.
            )
            goto END
        )
        
        set productName=!keyName%%i!
        echo productName=!productName! >>!logFile!

        set /A exists=0
        call:SingleProduct
        echo exists=!exists! >>!logFile!
        if NOT !exists!==0 (
            if /i "!relation!"=="OR" (
                if "!productInst!"=="InstLISM" (
                set InstManagerLI=1
                )

                if "!productInst!"=="InstManager" (
                set InstManager=1
                )

                if "!productInst!"=="InstLISA" (
                set InstAgentLI=1
                )

                if "!productInst!"=="InstAgent" (
                set InstAgent=1
                )
                
                goto END
            )
        ) else (
            if /i "!relation!"=="OR" (
                set allProduct=!allProduct!,!productName!
            ) else (   
                set /A errorFlag=1
                set errorMessage=Product !productName! is not installed.
                goto END          
            )
        )
    )
    echo ----------End check product(s)---------->>!LogFile!

    goto END
)

:SingleProduct (
    REG QUERY "!regAlertMan!" /v !productInst! >>!logFile! 2>nul
    if NOT !ERRORLEVEL!==0 (
        echo !regAlertMan! /v !productInst! not exist >>!logFile!
    ) else (
        echo !regAlertMan!\!productInst! exist >>!logFile!
        for /F "tokens=3" %%j in ('REG QUERY "!regAlertMan!" /v !productInst!') do (
            set /A exists=%%j
        )
    )

    goto END
)

:Excute (
    echo ----------Start Excute update Package---------->>!LogFile!
    
    set check=!keyValue0!
    echo check=!check! >>!logFile!
    if /i NOT "!check!"=="TRUE" (
        goto END
    )
    
    echo ReportEngine Install begin.
    cd ESMALERT
    if !InstManagerLI!==1 (
        set InstManager=0
        set InstAgentLI=0
        set InstAgent=0
        echo Commandline is AMSetup.exe /M LISM. >>!LogFile!
        AMSetup.exe /M LISM 
    )
    if !InstAgentLI!==1 (
        set InstAgent=0
        set InstManager=0
        set InstManagerLI=0
        echo Commandline is AMSetup.exe /M LISA. >>!LogFile!
        AMSetup.exe /M LISA 
    )
    if !InstManager!==1 (
        set InstAgent=0
        set InstAgentLI=0
        set InstManagerLI=0
        echo Commandline is AMSetup.exe /M ServerManager. >>!LogFile!
        AMSetup.exe /M ServerManager 
    )
    if !InstAgent!==1 (
        set InstAgentLI=0
        set InstManager=0
        set InstManagerLI=0
        echo Commandline is AMSetup.exe /M ServerAgent. >>!LogFile!
        AMSetup.exe /M ServerAgent 
    )

    
    cd..
    :findPro
    for /F "tokens=1*" %%i in ('tasklist ^|find "Amsetup.exe"') do (
        set pro=%%i
        if "!pro!"=="Amsetup.exe" (
           echo Amsetup.exe is still active ! Wait!  >>!LogFile!
           goto findPro
        )
     )

    REG QUERY "!regAlertMan!" /v AMVer 1>nul 2>nul
    if NOT !ERRORLEVEL!==0 (
        set /A errorFlag=1
        set errorMessage=Check install state failed.
        goto END
    )
   
    for /F "tokens=2*" %%i in ('REG QUERY "!regAlertMan!" /v AMVer') do (
        set AMver=%%j
        if "!AMver!"=="5.02" (
           goto ExcuteEnd
        ) else (
           set /A errorFlag=1
           set errorMessage=ReportEngine Install Failed.
           goto END           
        )
      )

	
   :ExcuteEnd
     echo ReportEngine Install is  completed.
     echo ----------End Excute update Package---------->>!LogFile! 
     goto END
)

:Service (
    echo ----------Start check if service is installed---------- >>!logFile!

    set check=!keyValue0!
    echo check=!check! >>!logFile!
    if /i NOT "!check!"=="TRUE" (
        goto END
    )
    echo Check if service is installed

    set relation=!keyValue1!
    echo relation=!relation!>>!logFile!

    set /A state=1
    set allService=
    set keyValue11=
    for /L %%i in (2, 1, 11) do (
        set serviceName=!keyValue%%i!
        echo serviceName=!serviceName! >>!logFile!
        if "!serviceName!"=="" (
            if !state!==0 (
                set /A errorFlag=1
                set allService=!allService:~1!
                set errorMessage=You must install one of those service(s^) as following:!allService!.
            )
            goto END
        )

        set displayName=!keyName%%i!
        echo displayName=!displayName! >>!logFile!
        
        set /A state=0
        call:QueryService
        echo state=!state! >>!logFile!
        if NOT !state!==0 (
            if /i "!relation!"=="OR" (
                goto END
            )
        ) else (
            if /i "!relation!"=="OR" (
                set allService=!allService!,!displayName!
            ) else (   
                set /A errorFlag=1
                set errorMessage=Service !displayName! is not installed.
                goto END          
            )
        )
    )
    echo ----------End check service---------- >>!logFile!
    goto END
)

:QueryService  (    
    echo ----------Start query service----------  >>!logFile!
    SC QUERY !serviceName! >>!logFile!
    for /F "tokens=1,2,3" %%i in ('SC QUERY !serviceName!') do (
        if /i "%%i"=="STATE" (
            set state=%%k
            goto END
        )  
    )    
    echo ----------End query service----------  >>!logFile!
    goto END
)

:File (
    echo ----------Check if file(s) exists---------- >>!logFile!

    set check=!keyValue0!
    echo check=!check! >>!logFile!
    if /i NOT "!check!"=="TRUE" (
        goto END
    )
    echo Check if file(s) exists

    set relation=!keyValue1!
    echo relation=!relation!>>!logFile!

    set destID=!keyValue2!
    echo destID=!destID!>>!logFile!

    set /A exists=1
    set allFile=
    set keyValue11=
    for /L %%i in (3, 1, 11) do (
        set filePath=!keyValue%%i!
        echo filePath=!filePath! >>!logFile!
        if "!filePath!"=="" (
            if !exists!==0 (
                set /A errorFlag=1
                set allFile=!allFile:~1!
                set errorMessage=You must install one of those file(s^) as following:!allFile!.
            )
            goto END
        )

        if /i "!destID!"=="REG" (
            call:ExpandRegPath
            if !errorFlag!==1 (
                goto END
            ) 
        )
        echo expandRegPath=!filePath!

        call:ExpandFilePath
        if NOT !errorFlag!==0 (
            goto END
        )
        echo expandFilePath=!filePath! >>!logFile!
        if EXIST "!filePath!" (
            if /i "!relation!"=="OR" (
                goto END
            )
        ) else (
            if /i "!relation!"=="OR" (
                set /A exists=0
                set allFile=!allFile!,!filePath!
            ) else (   
                set /A errorFlag=1
                set errorMessage=!filePath! is not exist.
                goto END          
            )
        )
    )
    echo ----------End check files---------- >>!logFile!
    goto END
)

:ExpandRegPath (
    echo ----------Start expand reg---------- >>!logFile!
    for /F "tokens=1,2 delims=/v" %%i in ("!filePath!") do (
        set regKey=%%i
        set regValueFile=%%j
        for /F "tokens=1* delims=\\" %%a in ("!regValueFile!") do (
            set regValue=%%a
            set fileName=%%b
        )
    )
    echo regKey=!regKey! >>!logFile!
    echo regValue=!regValue! >>!logFile!
    echo fileName=!fileName! >>!logFile!
    set regPath=!regSoftWare!\!regKey!
    REG QUERY "!regPath!" /v !regValue! >>!logFile! 2>nul
    if NOT !ERRORLEVEL!==0 (
        set /A errorFlag=1
        set errorMessage=Registry value !regValue! of !regPath!  is not exist.
        goto END
    )

    for /F "tokens=2*" %%i in ('REG QUERY "!regPath!" /v !regValue!') do (
        set filePath=%%j\!fileName!
    )
    echo ----------End expand reg---------- >>!logFile!
    goto END
)

:ExpandFilePath (
    echo ----------Start expand file path---------- >>!logFile!
    set /A index=0
    set expandPath=
    set /A envFlag=0
    set env=

    :GetFileName (
        set character=!filePath:~%index%,1!
        if "!character!"=="" (
            if !envFlag!==1 (
                set /A errorFlag=1
                set errorMessage=The format of file path !filePath! is not correct.
            )
            set filePath=!expandPath!
            echo ----------END expand file path---------- >>!logFile!
            goto END
        )
        if "!character!"=="%%" (
            if !envFlag!==0 (
                set /A envFlag=1
            ) else (
                for /F "tokens=2 delims==" %%i in ('set !env!') do (
                    set expandPath=!expandPath!%%i
                )
                set /A envFlag=0
            )
        ) else (
            if !envFlag!==1 (
                set env=!env!!character!
            ) else (
                set expandPath=!expandPath!!character!
            )
        )
        set /A index=!index!+1
        goto GetFileName
    )

    echo ----------End expand file path---------- >>!logFile!
    goto END
)

:Registry (
    echo ----------Start check registry---------- >>!logFile!

    set check=!keyValue0!
    echo check=!check! >>!logFile!
    if /i NOT "!check!"=="TRUE" (
        goto END
    )
    
    echo Check registry
    set relation=!keyValue1!
    echo relation=!relation! >>!logFile!

    set /A exists=1
    set allRegistry=
    set keyValue11=
    for /L %%i in (2, 1, 11) do (
        set keyOrValueName=!keyName%%i!
        echo keyOrValueName=!keyOrValueName! >>!logFile!
        if "!keyOrValueName!"=="" (
            if !exists!==0 (
                if /i "!relation!"=="OR" (
                    set /A errorFlag=1
                    set allRegistry=!allRegistry:~1!
                    set errorMessage=The following registry not exist(s^) or not is not suitable for the update. !allRegistry!.
                )
            )
            goto END
        )

        set /A exists=1
        REG QUERY !keyOrValueName! >>!logFile! 2>nul
        if NOT !ERRORLEVEL!==0 (
            echo !keyOrValueName! not exist >>!logFile!
            set /A exists=0
        )
        echo exists=!exists! >>!logFile!
        if !exists!==0 (
            if /i "!relation!"=="OR" (
                set allRegistry=!allRegistry!,!keyOrValueName!
            ) else (
                set /A errorFlag=1
                set errorMessage=Registry !keyOrValueName! is not exists.
                goto END
            )
        ) else (
            set typeAndValue=!keyValue%%i!
            echo typeAndValue=!keyValue%%i! >>!logFile!
            call:CompareReg
            if !errorFlag!==1 (
                if /i "!relation!"=="OR" (
                    set allRegistry=!allRegistry!,!keyOrValueName!
                    set /A exists=0
                    set errorFlag=0
                ) else (
                   set errorMessage=Registry !keyOrValueName! is not suitable for the update.
                   goto END
                )
            ) else if /i "!relation!"=="OR" (
                goto END
            )
        )
    )
    echo ----------End check registry---------- >>!logFile!
    goto END
)


:CompareReg (
    echo ----------Start compare registry value---------- >>!logFile!
    echo typeAndValue=!typeAndValue! >>!logFile!
    if "!typeAndValue!"=="" (
        goto END
    )
    
    for /F "tokens=1,2,3" %%i in ("!typeAndValue!") do (
        set type=%%i
        set min=%%j
        set max=%%k
    )
    echo type=!type! >>!logFile!
    echo min=!min! >>!logFile!
    echo max=!max! >>!logFile!
    
    for /F "tokens=2*" %%i in ('REG QUERY !keyOrValueName!') do (
        set regValue=%%j
    )
    echo !keyOrValueName!=!regValue! >>!logFile!

    if /i "!type!"=="NUMBER" (
        set number1=!regValue!
        set number2=!min!
        call:CompareNumber
        if !compare!==-1 (
            set /A errorFlag=1
            goto END
        )

        set number2=!max!
        call:CompareNumber
        if !compare!==1 (
            set /A errorFlag=1
            goto END
        )
    ) else (
        set string1=!regValue!
        set string2=!min!
        call:CompareString
        if !compare!==-1 (
            set /A errorFlag=1
            goto END
        )
        
        set string2=!max!
        call:CompareString
        if !compare!==1 (
            set /A errorFlag=1
            goto END
        )
    )    
    
    echo errorFlag=!errorFlag! >>!logFile
    echo ----------End compare registry value---------- >>!logFile!
    goto END
)

:CompareString (    
    echo ----------Start compare string---------- >>!logFile!
    echo string1=!string1! >>!logFile!
    echo string2=!string2! >>!logFile!
    
    set /A compare=0
    if /i !string1! LSS !string2! (
        set /A compare=-1
    ) else if /i !string1! GTR !string2! (
        set /A compare=1
    )
    
    echo compare=!compare! >>!logFile!
    echo ----------End compare string---------- >>!logFile!
    goto END
)

:StopService (
    echo ----------Start stop service---------- >>!logFile!

    set stop=!keyValue0!
    echo stop=!stop! >>!logFile!
    if /i NOT "!stop!"=="TRUE" (
        goto END
    )
    echo Stop service(s)

    for /L %%i in (1, 1, 100) do (
        set serviceName=!keyValue%%i!
        echo serviceName=!serviceName!>>!logFile!
        if "!serviceName!"=="" (
            goto END
        )

        call:StopSingleService
        if !errorFlag!==1 (
            set displayName=!keyName%%i!
            set errorMessage=Stop service !displayName! failed.
            goto END
        )
    )
    echo ----------End stop service---------- >>!logFile!
    goto END
)

:StopSingleService (
    echo ---------- Start stop service !serviceName!---------- >>!logFile!
    set /A state=0
    call:QueryService
    echo state=!state! >>!logFile!
    if NOT !state!==4 (
        goto END
    )

    echo stop service !serviceName!
    SC STOP !serviceName! >>!logFile!
    for /L %%a in (1, 1, 12) do (
        set /A state=0
        call:QueryService
        echo state=!state! >>!logFile!
        if NOT !state!==1 (
            ping -n 5 127.0.0.1 >nul
         ) else (
            set stoppedService=!stoppedService!!serviceName!,
            echo stoppedService=!stoppedService! >>!logFile!
            goto END
        )  
    )

    if NOT !state!==1 (
        set /A errorFlag=1
    )

    echo ----------End stop service !serviceName!---------- >>!logFile!
    goto END
)

:RestartService (
    echo ----------Start restart service---------- >>!logFile!
    echo stoppedService=!stoppedService! >>!logFile!
    if "!stoppedService!"=="" (
        goto END
    )
    echo Restart Service

    set /A index=0
    set serviceName=
    :GetServiceName (
        set character=!stoppedService:~%index%,1!
        if "!character!"=="" (
            goto END
        )

       if "!character!"=="," (
            echo ServiceName=!serviceName! >>!logFile!
            set /A state=0
            call:QueryService
            echo state=!state! >>!logFile!
            if NOT !state!==4 (
                SC START !serviceName! >>!logFile!   
                if NOT !ERRORLEVEL!==0 (
                  echo Start service !serviceName! failed. >>!logFile!
                  echo Restart service !serviceName! failed.
                )
            )
            set serviceName=
        ) else (
            set serviceName=!serviceName!!character!
        )
        set /A index=!index!+1
        goto GetServiceName
    )
    echo ----------End restart service---------- >>!logFile!
    goto END
)

:CopyFile (
    echo ----------Start copy file(s)---------- >>!logFile!

    set copy=!keyValue0!
    echo copy=!copy! >>!logFile!
    if /i NOT "!copy!"=="TRUE" (
        goto END
    )
    echo Copy file(s)

    set destID=!keyValue1!
    echo destID=!destID!>>!logFile!

    for /L %%i in (2, 1, 10) do (
        set sourceName=!workDir!Module\!keyName%%i!
        echo sourceName= !sourceName! >>!logFile!
        if "!sourceName!"=="" (
            goto END
        )

        if NOT EXIST "!sourceName!" (
            echo File !sourceName! does not exist.  >>!logFile!
            set /A errorFlag=1
            set errorMessage=File !sourceName! does not exist.
            goto END
        )
        
        set filePath=!keyValue%%i!
        echo destName= !filePath! >>!logFile!
        if "!filePath!"=="" (
            goto END
        )

        if /i "!destID!"=="REG" (
            call:ExpandRegPath
            if !errorFlag!==1 (
                goto END
            ) 
        )
        echo expandRegPath=!filePath! >>!logFile!

        call:ExpandFilePath
        if NOT !errorFlag!==0 (
            goto END
        )
        echo expandFilePath=!filePath! >>!logFile!
        set destName=!filePath!

        if EXIST "!destName!" (
            if NOT EXIST "!destName!.bak" (
                echo backup !destName! to !destName!.bak >>!logFile!
                echo F|XCOPY /D /Y /Q "!destName!" "!destName!.bak" >>!logFile!
            )
        )

        echo copy "!sourceName!" to "!destName!" >>!logFile!
        echo F|XCOPY /D /Y /Q "!sourceName!" "!destName!" >>!logFile!
        if NOT !ERRORLEVEL!==0 (
            set /A errorFlag=1
            set errorMessage=Copy file from !sourceName! to !destName! failed.
            goto END
        )
    )   
    echo ----------End copy file(s)---------- >>!logFile!
    goto END    
)

:ImportRegistry (
    echo ----------Start import registry---------- >>!logFile!
    set import=!keyValue0!
    echo import=!import! >>!logFile!
    if /i NOT "!import!"=="TRUE" (
        goto END
    )
    
    echo Start import registry
    set overWrite=!keyValue1!
    echo overWrite=!overWrite! >>!logFile!
    
    for /L %%i in (2, 1, 10) do (
        set fileName=!keyValue%%i!
        echo fileName=!fileName! >>!logFile!
        if "!fileName!"=="" (
            goto END
        )
        
        set regKey=!keyName%%i!
        echo regKey=!regKey! >>!logFile!
        
        set /A regKeyExist=0
        if /i "!overWrite!"=="FALSE" (
            REG QUERY !regKey! >>!logFile! 2>nul
            if !ERRORLEVEL!==0 (
                set /A regKeyExist=1
            )
        )
        echo regKeyExist=!regKeyExist! >>!logFile!
        
        if !regKeyExist!==0 (
            set filePath="!workDir!Registry\!fileName!"
            echo filePath=!filePath! >>!logFile!
            if NOT EXIST !filePath! (
                set /A errorFlag=1
                set errorMessage=The registry file !filePath! is not exists.
                goto END
            )
            echo !filePath! exists >>!logFile!
            
            REG IMPORT !filePath! >>!logFile! 2>nul
            if NOT !ERRORLEVEL!==0 (
                set /A errorFlag=1
                set errorMessage=Create registry !regKey! failed.
                goto END
            )
        )
    )
    
    echo ----------END import registry---------- >>!logFile!
    goto END
)

:AddRegistry (
    echo ----------Start add registry---------- >>!logFile!

    set add=!keyValue0!
    echo add=!add! >>!logFile!
    if /i NOT "!add!"=="TRUE" (
        goto END
    )
    echo Add registry

    for /L %%i in (1, 1, 10) do (
        set keyOrValueName=!keyName%%i!
        if "!keyOrValueName!"=="" (
            goto END
        )

        set addString=!keyOrValueName!

        set keyValue=!keyValue%%i!
        if NOT "!keyValue!"=="" (
            for /F "tokens=1*" %%a in ("!keyValue!") do (
                if NOT "%%a"=="" (
                    set addString=!addString! /t %%a
                )
                if NOT "%%b"=="" (
                    set addString=!addString! /d %%b
                )
            ) 
        )

        set addString=!addString! /f
        echo addString=!addString! >>!logFile!
        REG ADD !addString!  >>!logFile!
        if NOT !ERRORLEVEL!==0 (            
            set /A errorFlag=1
            set errorMessage=Create registry !keyOrValueName! failed .
            goto END
        )
    )
    echo ----------End add registry---------- >>!logFile!
    goto END
)

:DelRegistry (
    echo ----------Start delete registry---------- >>!logFile!

    set del=!keyValue0!
    echo del=!del! >>!logFile!
    if /i NOT "!del!"=="TRUE" (
        goto END
    )
    echo Delete registry

    for /L %%i in (1, 1, 10) do (
        set keyOrValueName=!keyName%%i!
        echo keyOrValueName=!keyOrValueName! >>!logFile!
        if "!keyOrValueName!"=="" (
            goto END
        )
        REG DELETE !keyOrValueName! /f >>!logFile!
        if NOT !ERRORLEVEL!==0 (           
            set /A errorFlag=1
            set errorMessage=Delete registry !keyOrValueName! failed .
            goto END
        )
    )
    echo ----------End delete registry---------- >>!logFile!
    goto END
)

:EndPrint (    
    echo !errorMessage! >>!logFile!
    echo !errorMessage!
    
    echo ================ !time! END AMUpdate ================ >>!logFile!
    echo ============================================================ >>!logFile!
    echo ============================================================ >>!logFile!
    goto Terminate
)
:Terminate (
    pause
)

:END

